/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

void QG_DimOptions::setAction(RS_ActionInterface* a, bool update) {
    if (a!=NULL && RS_ActionDimension::isDimensionAction(a->rtti())) {
        action = (RS_ActionDimension*)a;
        
        QString st;
        if (update) {
            st = action->getText();
        } else {
            st = "";
        }
        leLabel->setText(st);
    } else {
        std::cerr << "QG_DimensionOptions::setAction: wrong action type\n";
        action = NULL;
    }
}



void QG_DimOptions::updateLabel() {
    if (action!=NULL) {
        QString l = leLabel->text();
        
        if (l.isEmpty() && 
             (bDiameter->isOn() || !leTol1->text().isEmpty() || !leTol2->text().isEmpty())) {
            l = "<>";
        }
        
        if (bDiameter->isOn()) {
            l = QChar(0x2205) + l;
        }
        
        if (!leTol1->text().isEmpty() || !leTol2->text().isEmpty()) {
            l += QString("\\S%1/%2;").arg(leTol1->text()).arg(leTol2->text());
        }
       
        action->setText(l);
  }
}

void QG_DimOptions::insertSign(const QString& c) {
    leLabel->insert(c);
}


/*void QG_DimOptions::toggleHelper(bool on) {
    static QG_DimensionLabel* dl = NULL;
    
    if (on) {
        dl = new QG_DimensionLabel(NULL, "Dimension Label Helper", 
                                   WType_Popup|WStyle_NoBorder|WStyle_StaysOnTop);
        dl->move(dl->mapToGlobal(bHelper->pos())+);
        dl->show();
    }
    else {
        if (dl!=NULL) {
            delete dl;
            dl=NULL;
        }
    }
}*/
